// https://www.airspayce.com/mikem/arduino/AccelStepper/
// https://www.airspayce.com/mikem/arduino/AccelStepper/MultipleSteppers_8pde-example.html
#include <AccelStepper.h>

AccelStepper stepper1(AccelStepper::HALF4WIRE, 16, 14, 13, 17, true);
AccelStepper stepper2(AccelStepper::HALF4WIRE, 26, 33, 25, 27, true);

float sp1=1000.0;
float acc1=3200.0;
int rnd1=0;
float sp2=800.0;
float acc2=3200.0;
int en1=0;
int en2=0;
long tst=0;
float mv1b_pos_f = 0.0;
int mv1b_pos_i = 0;

int sign(int i) {
  if (i<0) return -1;
  return 1;
}

void move1(int dir=1) {
  int stp=341*sign(dir);
  if (abs(dir)==1) {
    if ((rnd1==2) && (dir==+1)) {stp++;}
    if ((rnd1==0) && (dir==-1)) {stp--;}
    rnd1+=dir;
    if (rnd1<0) {rnd1=2;} 
    if (rnd1>2) {rnd1=0;} 
  } else stp=stp/abs(dir);
  en1=1;
  stepper1.move(stp);
  tst+=stp;
  Serial.println(tst);
}

void move1b(int dir=1) {
  float delta_stp = (1024.0/3.0) /float(dir);
  int target_stp = int(delta_stp + mv1b_pos_f) - mv1b_pos_i;
  mv1b_pos_f += delta_stp;
  mv1b_pos_i += target_stp;
  if (mv1b_pos_i > 1000000) {
    mv1b_pos_f -= 500000.0;
    mv1b_pos_i -= 500000;
  }
  if (mv1b_pos_i < -1000000) {
    mv1b_pos_f += 500000.0;
    mv1b_pos_i += 500000;
  }
  en1=1;
  stepper1.move(delta_stp);
  Serial.print(delta_stp); Serial.print(" "); Serial.print(mv1b_pos_f); Serial.print(" "); Serial.println(mv1b_pos_i);
}

void move2(int dir=1) {
  int stp=400/dir;
  en2=1;
  stepper2.move(stp);
}

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  Serial.println("Starting");
  stepper1.setMaxSpeed(sp1);
  stepper1.setAcceleration(acc1);
  stepper2.setMaxSpeed(sp2);
  stepper2.setAcceleration(acc2);
  Serial.println("End setup");
  Serial.println("Aa/Bb : one frame / back");
  Serial.println("Cc/Dd : one step / back");
  Serial.println("Ee/Ff : continious / back");
  Serial.println("Gg/Hh : one third frame / back");
  Serial.println("Qq    : Quit moving");
  Serial.println("Ww/Xx : decrease / incraese accel");
  Serial.println("Yy/Zz : decrease / incraese speed");
}

void hanlde_input(int inb) {
  if (inb=='A') {move1(+1);}
  if (inb=='B') {move1(-1);}
  if (inb=='G') {move1b(+3);}
  if (inb=='H') {move1b(-3);}
  if (inb=='C') {en1=1;stepper1.move(+1);}
  if (inb=='D') {en1=1;stepper1.move(-1);}
  if (inb=='E') {en1=1;stepper1.move(+1000000);}
  if (inb=='F') {en1=1;stepper1.move(-1000000);}
  if (inb=='W') {acc1/=2.0; stepper1.setAcceleration(acc1); Serial.println(acc1);}
  if (inb=='X') {acc1*=2.0; stepper1.setAcceleration(acc1); Serial.println(acc1);}
  if (inb=='Y') {sp1/=2.0; stepper1.setMaxSpeed(sp1); Serial.println(sp1);}
  if (inb=='Z') {sp1*=2.0; stepper1.setMaxSpeed(sp1); Serial.println(sp1);}
  if (inb=='Q') {stepper1.stop(); Serial.println("Q1");}
  if (inb=='a') {move2(+1);}
  if (inb=='b') {move2(-1);}
  if (inb=='g') {move2(+3);}
  if (inb=='h') {move2(-3);}
  if (inb=='c') {en2=1;stepper2.move(+1);}
  if (inb=='d') {en2=1;stepper2.move(-1);}
  if (inb=='e') {en2=1;stepper2.move(+1000000);}
  if (inb=='f') {en2=1;stepper2.move(-1000000);}
  if (inb=='w') {acc2/=2.0; stepper2.setAcceleration(acc2); Serial.println(acc2);}
  if (inb=='x') {acc2*=2.0; stepper2.setAcceleration(acc2); Serial.println(acc2);}
  if (inb=='y') {sp2/=2.0; stepper2.setMaxSpeed(sp2); Serial.println(sp2);}
  if (inb=='z') {sp2*=2.0; stepper2.setMaxSpeed(sp2); Serial.println(sp2);}
  if (inb=='q') {stepper2.stop(); Serial.println("q2");}

}

void loop() {
  // put your main code here, to run repeatedly:

  boolean rn1=stepper1.run();
  boolean rn2=stepper2.run();

  if ((en1==1) && (!rn1)) {en1=0; Serial.println("E1");}
  if ((en2==1) && (!rn2)) {en2=0; Serial.println("E2");}

  if (Serial.available() > 0) {
    int inb = Serial.read();
    hanlde_input(inb);
  }

}


